read(fd, address, length) {
	return syscall(0, fd, address, length)
}

write(fd, address, length) {
	return syscall(1, fd, address, length)
}

open(file, flags, mode) {
	return syscall(2, file, flags, mode)
}

close(fd) {
	return syscall(3, fd)
}

mmap(address, length, protection, flags) {
	return syscall(9, address, length, protection, flags)
}

munmap(address, length) {
	return syscall(11, address, length)
}

clone(flags, stack) {
	return syscall(56, flags, stack)
}

exit(code) {
	syscall(60, code)
}

socket(family, type, protocol) {
	return syscall(41, family, type, protocol)
}

accept(fd, address, length) {
	return syscall(43, fd, address, length)
}

bind(fd, address, length) {
	return syscall(49, fd, address, length)
}

listen(fd, backlog) {
	return syscall(50, fd, backlog)
}

getcwd(buffer, length) {
	return syscall(79, buffer, length)
}

chdir(path) {
	return syscall(80, path)
}

rename(old, new) {
	return syscall(82, old, new)
}

mkdir(path, mode) {
	return syscall(83, path, mode)
}

rmdir(path) {
	return syscall(84, path)
}

unlink(file) {
	return syscall(87, file)
}
