package asm

import "maps"

// Assembler contains a list of instructions.
type Assembler struct {
	Data         map[string][]byte
	Instructions []Instruction
}

// Merge combines the contents of this assembler with another one.
func (a *Assembler) Merge(b Assembler) {
	maps.Copy(a.Data, b.Data)
	a.Instructions = append(a.Instructions, b.Instructions...)
}

// SetData sets the data for the given label.
func (a *Assembler) SetData(label string, data []byte) {
	if a.Data == nil {
		a.Data = map[string][]byte{}
	}

	a.Data[label] = data
}
