package core

import (
	"fmt"

	"git.akyoto.dev/cli/q/src/build/asm"
	"git.akyoto.dev/cli/q/src/build/ast"
)

// CompileLoop compiles a loop instruction.
func (f *Function) CompileLoop(loop *ast.Loop) error {
	f.count.loop++
	label := fmt.Sprintf("%s_loop_%d", f.Name, f.count.loop)
	f.AddLabel(label)
	scope := f.PushScope(loop.Body, f.File.Bytes)
	scope.InLoop = true
	err := f.CompileAST(loop.Body)
	f.Jump(asm.JUMP, label)
	f.PopScope()
	return err
}
