package core

import (
	"git.akyoto.dev/cli/q/src/build/cpu"
	"git.akyoto.dev/cli/q/src/build/expression"
	"git.akyoto.dev/cli/q/src/build/token"
)

// Evaluate evaluates an expression and returns a register that contains the value of the expression.
func (f *Function) Evaluate(expr *expression.Expression) (cpu.Register, error) {
	if expr.Token.Kind == token.Identifier {
		name := expr.Token.Text(f.File.Bytes)
		variable := f.VariableByName(name)

		if variable.Alive == 1 {
			f.UseVariable(variable)
			return variable.Register, nil
		}
	}

	tmp := f.NewRegister()
	err := f.ExpressionToRegister(expr, tmp)
	return tmp, err
}
