package core

import (
	"git.akyoto.dev/cli/q/src/build/cpu"
	"git.akyoto.dev/cli/q/src/build/expression"
)

// ExpressionsToRegisters moves multiple expressions into the specified registers.
func (f *Function) ExpressionsToRegisters(expressions []*expression.Expression, registers []cpu.Register) error {
	for i := len(registers) - 1; i >= 0; i-- {
		err := f.ExpressionToRegister(expressions[i], registers[i])

		if err != nil {
			return err
		}
	}

	return nil
}
