package core

import (
	"git.akyoto.dev/cli/q/src/build/asm"
	"git.akyoto.dev/cli/q/src/build/token"
)

// JumpIfTrue jumps to the label if the previous comparison was true.
func (f *Function) JumpIfTrue(operator token.Kind, label string) {
	switch operator {
	case token.Equal:
		f.Jump(asm.JE, label)
	case token.NotEqual:
		f.Jump(asm.JNE, label)
	case token.Greater:
		f.Jump(asm.JG, label)
	case token.Less:
		f.Jump(asm.JL, label)
	case token.GreaterEqual:
		f.Jump(asm.JGE, label)
	case token.LessEqual:
		f.Jump(asm.JLE, label)
	}
}
