package errors

import "fmt"

// UnusedImport error is created when an import is never used.
type UnusedImport struct {
	Package string
}

// Error generates the string representation.
func (err *UnusedImport) Error() string {
	return fmt.Sprintf("Unused import '%s'", err.Package)
}
