package errors

import "fmt"

// UnusedVariable error is created when a defined variable is never used.
type UnusedVariable struct {
	Name string
}

// Error generates the string representation.
func (err *UnusedVariable) Error() string {
	return fmt.Sprintf("Unused variable '%s'", err.Name)
}
