package fs_test

import (
	"testing"

	"git.akyoto.dev/cli/q/src/build/fs"
	"git.akyoto.dev/go/assert"
)

func TestWalk(t *testing.T) {
	var files []string

	err := fs.Walk(".", func(file string) {
		files = append(files, file)
	})

	assert.Nil(t, err)
	assert.Contains(t, files, "Walk.go")
	assert.Contains(t, files, "Walk_test.go")
}

func TestWalkFile(t *testing.T) {
	err := fs.Walk("Walk.go", func(file string) {})
	assert.NotNil(t, err)
}

func TestWalkNonExisting(t *testing.T) {
	err := fs.Walk("does-not-exist", func(file string) {})
	assert.NotNil(t, err)
}
