package register

import (
	"git.akyoto.dev/cli/q/src/build/asm"
	"git.akyoto.dev/cli/q/src/build/cpu"
	"git.akyoto.dev/cli/q/src/build/sizeof"
)

func (f *Machine) RegisterNumber(mnemonic asm.Mnemonic, a cpu.Register, b int) {
	if f.RegisterIsUsed(a) && isDestructive(mnemonic) {
		f.SaveRegister(a)
	}

	if sizeof.Signed(int64(b)) == 8 {
		tmp := f.NewRegister()
		f.Assembler.RegisterNumber(asm.MOVE, tmp, b)
		f.UseRegister(tmp)
		f.postInstruction()
		f.Assembler.RegisterRegister(mnemonic, a, tmp)
		f.postInstruction()
		f.FreeRegister(tmp)
	} else {
		f.Assembler.RegisterNumber(mnemonic, a, b)
		f.postInstruction()
	}

	if mnemonic == asm.MOVE {
		f.UseRegister(a)
	}
}
