package token

// Kind represents the type of token.
type Kind uint8

const (
	Invalid         Kind = iota // Invalid is an invalid token.
	EOF                         // EOF is the end of file.
	NewLine                     // NewLine is the newline character.
	Identifier                  // Identifier is a series of characters used to identify a variable or function.
	Number                      // Number is a series of numerical characters.
	Rune                        // Rune is a single unicode code point.
	String                      // String is an uninterpreted series of characters in the source code.
	Comment                     // Comment is a comment.
	GroupStart                  // (
	GroupEnd                    // )
	BlockStart                  // {
	BlockEnd                    // }
	ArrayStart                  // [
	ArrayEnd                    // ]
	_keywords                   // <keywords>
	Assert                      // assert
	Else                        // else
	If                          // if
	Import                      // import
	Loop                        // loop
	Return                      // return
	_keywordsEnd                // </keywords>
	_operators                  // <operators>
	Add                         // +
	Sub                         // -
	Mul                         // *
	Div                         // /
	Mod                         // %
	And                         // &
	Or                          // |
	Xor                         // ^
	Shl                         // <<
	Shr                         // >>
	LogicalAnd                  // &&
	LogicalOr                   // ||
	Equal                       // ==
	Less                        // <
	Greater                     // >
	NotEqual                    // !=
	LessEqual                   // <=
	GreaterEqual                // >=
	Define                      // :=
	Period                      // .
	Call                        // x()
	Array                       // [x]
	Separator                   // ,
	_unary                      // <unary>
	Not                         // ! (unary)
	Negate                      // - (unary)
	_unaryEnd                   // </unary>
	_assignments                // <assignments>
	Assign                      // =
	AddAssign                   // +=
	SubAssign                   // -=
	MulAssign                   // *=
	DivAssign                   // /=
	ModAssign                   // %=
	AndAssign                   // &=
	OrAssign                    // |=
	XorAssign                   // ^=
	ShlAssign                   // <<=
	ShrAssign                   // >>=
	_assignmentsEnd             // </assignments>
	_operatorsEnd               // </operators>
)
