package cli

import (
	"fmt"
	"os"
	"os/exec"

	"git.akyoto.dev/cli/q/src/build/errors"
)

// Run builds and runs the executable.
func Run(args []string) int {
	b, err := buildWithArgs(args)

	if err != nil {
		fmt.Fprintln(os.Stderr, err)

		switch err.(type) {
		case *errors.UnknownCLIParameter:
			return 2

		default:
			return 1
		}
	}

	cmd := exec.Command(b.Executable())
	cmd.Stdout = os.Stdout
	cmd.Stdin = os.Stdin
	cmd.Stderr = os.Stderr
	err = cmd.Run()

	if err != nil {
		fmt.Fprintln(os.Stderr, err)

		switch err.(type) {
		case *exec.ExitError:
			return 0

		default:
			return 1
		}
	}

	return 0
}
