package cli

import (
	"fmt"
	"runtime"
	"strconv"

	"git.akyoto.dev/cli/q/src/build/config"
)

// System shows system information.
func System(args []string) int {
	line := "%-19s%s\n"
	fmt.Printf(line, "Platform:", runtime.GOOS)
	fmt.Printf(line, "Architecture:", runtime.GOARCH)
	fmt.Printf(line, "Go:", runtime.Version())
	fmt.Printf(line, "Directory:", config.WorkingDirectory)
	fmt.Printf(line, "Compiler:", config.Executable)
	fmt.Printf(line, "Library:", config.Library)
	fmt.Printf(line, "Threads:", strconv.Itoa(runtime.NumCPU()))

	return 0
}
